extends Node

var arrayHeaders = PackedStringArray([
	"Origin: https://aoe2lobby.com/ws/spectate",
])

var socket: WebSocketPeer

@onready var find_button: Button = %FindButton

func _ready(): 
	set_process(false)

func startConnection():
	socket = WebSocketPeer.new()
	socket.handshake_headers = arrayHeaders 
	var error = socket.connect_to_url(Global.URL_SPEC_WSS)
	if error != OK:
		print("Failed to start WebSocket connection: ", error)
	else:
		set_process(true)

func disconnectFromSpecSite():
	print("disconnecting web socket")
	socket.close()

func _process(delta):
	socket.poll()
		
	match socket.get_ready_state():
		WebSocketPeer.STATE_CONNECTING:
			print("Connecting to WebSocket...")
		
		WebSocketPeer.STATE_OPEN:
			var n = socket.get_available_packet_count()
			if n > 0:
				print(socket.get_packet())
			#var buffer = ""
			#while socket.get_available_packet_count() > 0:
				#var packet = socket.get_packet()
				#buffer += packet.get_string_from_utf8()
			#print(buffer.substr(0,100))
			
			#var jsonData = JSON.parse_string(buffer)
			#if jsonData:
				#find_button.updateSpecs(jsonData)
				
		WebSocketPeer.STATE_CLOSING:
			print("Stopping WebSocket...")
			
		WebSocketPeer.STATE_CLOSED:
			var code = socket.get_close_code()
			var reason = socket.get_close_reason()
			print("WebSocket closed with code: %d, reason %s. Clean: %s" % [code, reason, code != -1])
			set_process(false) # Stop processing.


func _on_button_pressed() -> void:
	startConnection()
